package org.mvplugins.multiverse.core.commands;

import co.aikar.commands.annotation.CommandAlias;
import co.aikar.commands.annotation.CommandCompletion;
import co.aikar.commands.annotation.CommandPermission;
import co.aikar.commands.annotation.Description;
import co.aikar.commands.annotation.Subcommand;
import co.aikar.commands.annotation.Syntax;
import jakarta.inject.Inject;
import org.jetbrains.annotations.NotNull;
import org.jvnet.hk2.annotations.Service;

import org.mvplugins.multiverse.core.anchor.AnchorManager;
import org.mvplugins.multiverse.core.commandtools.MVCommandIssuer;
import org.mvplugins.multiverse.core.commandtools.MVCommandManager;
import org.mvplugins.multiverse.core.commandtools.MultiverseCommand;

@Service
@CommandAlias("mv")
class AnchorDeleteCommand extends MultiverseCommand {

    private final AnchorManager anchorManager;

    @Inject
    AnchorDeleteCommand(@NotNull MVCommandManager commandManager, @NotNull AnchorManager anchorManager) {
        super(commandManager);
        this.anchorManager = anchorManager;
    }

    @Subcommand("anchor delete")
    @CommandPermission("multiverse.core.anchor.delete")
    @CommandCompletion("@anchornames")
    @Syntax("<name>")
    @Description("")
    void onAnchorDeleteCommand(
            MVCommandIssuer issuer,

            @Syntax("<name>")
            @Description("")
            String anchorName) {
        anchorManager.deleteAnchor(anchorName)
                .onSuccess(ignore -> issuer.sendMessage("&aAnchor &f'" + anchorName + "&a deleted."))
                .onFailure(e -> issuer.sendMessage("&cFailed to delete anchor. " + e.getMessage()));
    }
}
